Strict

Import pub.dreamotion3d

Const COUNT:Int = 64

Global box:CMesh
Global boxes:CMesh[COUNT , COUNT]
Global font:CFont

Global anglex:Float, angley:Float, flagXDown:Int
Global mox:Float, omx:Float, moy:Int, omy:Int

DM_Graphics3D(1024,768,32,2 ) '800 , 600 , 32 , 0 , 1)

font = DM_LoadFont( "Arial",8 ,0)
DM_TextColor(font , 255 , 255 , 255 , 255) 

ChangeDir("media")

box = DM_LoadMesh("box.x")

If Not box Then Print "oops"; End

Local i:Int, j:Int

For i = 0 Until COUNT
	For j = 0 Until COUNT
		boxes[i , j] = DM_CopyMesh( box ) 
		DM_PositionEntity(boxes[i , j], i*3, 0,j*3 )
		DM_EntityTexture(boxes[i , j], DM_LoadTexture("glass.bmp"))
	Next
Next

Global camera:CCamera = DM_CreateCamera()
DM_TranslateEntity(camera, 0,3,-25)
DM_CameraClsColor(camera, 0, 0, 0)

	Repeat

		If KeyDown(Key_W)
			DM_MoveEntity(camera, 0, 0, 0.5)
		ElseIf KeyDown(Key_S) 
			DM_MoveEntity(camera, 0, 0, - 0.5)
		Else If KeyDown(KEY_A)
			DM_MoveEntity(camera, 0.5, 0, 0)
		ElseIf KeyDown(KEY_D)
			DM_MoveEntity(camera, - 0.5, 0, 0)
		EndIf
		
		If MouseDown(1)
			If flagXDown=0
				omx = MouseX()
				omy = MouseY()
				flagXDown=11
			Else
				moy = MouseY()-omy
				angley=(moy/5.0)
				omy= MouseY()
				mox = MouseX()-omx
				anglex=(mox/5.0)
				omx= MouseX()
				DM_TurnEntity(camera, angley,anglex,0)
			EndIf
		Else
			flagXDown=0
		EndIf

		DM_BeginScene()

	    	DM_RenderWorld(camera)
	
		DM_DrawText(font, 10, 15, "FPS : "+DM_FPS()) 	 
	
		DM_EndScene()    
	
	Until KeyHit(Key_Escape)

	DM_ClearGraphics()
	
End
